rollout MultiplePositionsRollout "Multiple Positions"
(
	group "Multiple Objects"													-- gruppiere alle Rollout-Elemente
	(
	button btnSelect "Select" pos: [15,25] width: 50 height: 25
	button btnDelete "Delete" pos: [15,50] width: 50 height: 25
	button btnHide "Hide" pos: [65,25] width: 50 height: 25
	button btnUnhide "Unhide"  pos: [65,50] width: 50 height: 25
	button btnRandomObjects " " pos: [125, 125] height: 5 width: 5
	button btnRandomObjects2 " " pos: [0, 0] height: 5 width: 5
	button btnRandomObjects3 " " pos: [0, 125] height: 5 width: 5
	button btnRandomObjects4 " " pos: [125, 0] height: 5 width: 5
	button btnAnalize "   " pos: [100,85] width: 15 height: 15
	label lblStatus "Status:" pos:[15,85] style_sunkenedge:true height:16 width: 80 align: #center
	hyperlink hypHP "by xcEmUx" color: orange hovercolor: white visitedcolor: gray address:"www.xcEmUx.DAPortfolio.com" pos: [38,105]
	)
		global selectionarray = #() 											-- Variable fr alle Objekte
		global TempArray = #()												-- Variable fr Zwischenlagerung
		global RichtigerArray = #()											-- Variable fr Doppelte Objekte
	
	fn Suche =																		-- Funktion, die Objekte mit doppelten Positionen sucht
	(
		if selection != undefined do											-- Wenn etwas ausgewhlt ist...
		(
			for o in objects do append SelectionArray o					-- Sammle alle Objekte in "SelectionArray"
			
			for i = 1 to selectionarray.count do							-- Loop durch alle Objekte
			(
				a = TempArray.count											-- Speicher die Anzahl der Objekte in TempArray in Variable "a"
					
				appendifunique TempArray selectionarray[i].pos			-- Speicher Position von Objekt [i] des Selectionarrays in Temparray
					
				if TempArray.count == a + 1 then							-- Falls ein Objekt zum Temparray hinzugefgt wurde...
				(
					append RichtigerArray selectionarray[i]				-- Speicher dieses Objekt in RichtigerArray
				)
				else 																	-- ansonsten, tue nichts.
				(
				)
			)
			
			TempArray = #()														-- Arrays zum weiteren Gebrauch leeren
			SelectionArray = #()
		)
	)
	
	fn RandomObjects =															-- Funktion, die zwei Objekte auf der gleichen Position erstellt (fr Testzwecke)
	(
		for i = 1 to 5 do															-- Loope insgesamt fnf mal und...
		(
			randompos = [random -250 250, random -250 250, random -250 250] as point3	-- Definiere Zufllige 3D Koordinaten
			
			teapot pos: randompos												-- Erstelle eine Teekanne (Standard-Objekt) auf randompos
			sphere pos: randompos												-- Erstelle eine Sphere auf der gleiche Stelle
		)
		max views redraw
	)
	
	on btnAnalize pressed do
	(
		suche ()
		if richtigerarray.count != 0 then
		(
			txt =  RichtigerArray.count  as string
			lblStatus.text = txt + " Objekt(e)"
		)
	) -- end btnAnalize
	
	on btnSelect pressed do													-- Auf "Knopfdruck"
	(											
		suche ()																	-- Fhre die Funktion "Suche" aus
		select RichtigerArray														-- selektiere Objekte mit doppelter Position
	) -- end btnSelect
	
	on btnDelete pressed do													-- Siehe btnSelect, nur mit Lschen der doppelten Objekte
	(
		suche ()
		delete RichtigerArray
	) -- end btnDelete
	
	on btnHide pressed do														-- Siehe btnSelect, nur mit Verstecken der doppelten Objekte
	(
		suche ()
		hide RichtigerArray
	) -- end btnHide
	
	on btnUnhide pressed do													-- Siehe btnSelect, nur mit wieder Sichtbarmachen der doppelten Objekte
	(
		suche ()
		unhide RichtigerArray
	) -- end btnUnhide
	
	on btnRandomObjects pressed do										-- Erstelle zwei Objekte auf gleichen Positionen (Testzwecke)
	(
		RandomObjects ()
	) -- end btnRandomObjects
	
	on btnRandomObjects2 pressed do
	(
		RandomObjects ()
	) -- end btnRandomObjects2
	
	on btnRandomObjects3 pressed do
	(
		RandomObjects ()
	) -- end btnRandomObjects3
	
	on btnRandomObjects4 pressed do
	(
		RandomObjects ()
	) -- end btnRandomObjects4
	
) -- end MainRollout

createdialog MultiplePositionsRollout 130 130								-- Zeige das "Rollout" (in Delphi: "Form")