try
(

	rollout flashlightrollout "Flashlight v.0.1"
(
	local ViewCam = #()
	fn CameraFilter obj = classof obj == VRayPhysicalCamera
	
	pickbutton pckCamera "Pick Camera" autodisplay:true filter:CameraFilter width:180 height:18
	button btnCreateCam "Create VRay Camera from View" width:180 heigth:18 align:#center
	button btnexecute "Create Flashlight" height:18 width:180
	
	fn CreateFlashlight =
	(
		if pckCamera.object == undefined  then
		(
			CamObj = ViewCam [1]
		)
		else
		(
			CamObj = pckCamera.object
		)
		CamPos = CamObj.pos
		CamRot = CamObj.transform.rotationpart as Eulerangles
		CamRot.y = 0.0
		
		a = units.systemscale
		Lighttype = SettingRollout.drpType.selection - 1
		Size0 = SettingRollout.spnSize0.value / a
		Size1 = SettingRollout.spnSize1.value / a
		
		if Lighttype == 2 then
		(
			Flashlight = VRayLight type:LightType radius:Size0 subdivs:SettingRollout.spnSubdivs.value multiplier:SettingRollout.spnMultiplier.value color:SettingRollout.clrPick.color
		) 
		else
		(
			Flashlight = VRayLight type:LightType size1:Size1 size0:Size0 subdivs:SettingRollout.spnSubdivs.value multiplier:SettingRollout.spnMultiplier.value color:SettingRollout.clrPick.color
		)
		
		Flashlight.pos = CamPos
		rotate Flashlight CamRot
		Flashlight.parent = CamObj
		
		ViewCam = #()
	) -- end function CreateFlashlight
	
	fn CreateCam = 
	(
		macros.run "Lights and Cameras" "Camera_CreateFromView" 
		local CamName = uniquename "VRayPhysicalCamera_FromView" 
		vr = VRayPhysicalCamera targeted:false name: CamName
		append ViewCam vr
		vr.targeted = true
		vr.pos = $Camera001.pos
		vr.target.pos = $Camera001.target.pos
		delete $camera001
		actionMan.executeAction 0 "40068"
		select vr
		if querybox "Create a Flashlight ?" beep:true then
		(
			CreateFlashlight ()
		)
	) -- end function CreateCam
	
	on btnCreateCam pressed do
	(
		CreateCam ()
	)
	
	on btnexecute pressed do
	(
		if pckCamera.object != undefined  do
		(
			CreateFlashlight ()
		)
		if pckCamera.object == undefined and classof $ != VRayPhysicalCamera  then
		(
			if querybox "No Camera selected. \n Do you want to create a new Camera from View ?" beep:true then
			(
				macros.run "Lights and Cameras" "Camera_CreateFromView" 
				local CamName = uniquename "VRayPhysicalCamera_FromView" 
				vr = VRayPhysicalCamera targeted:false name: CamName
				append ViewCam vr
				vr.targeted = true
				vr.pos = $Camera001.pos
				vr.target.pos = $Camera001.target.pos
				delete $camera001
				actionMan.executeAction 0 "40068"
				if querybox "Create a Flashlight ?" beep:true then
				(
					CreateFlashlight ()
				)
			)
		)
	) -- end button execute	
	
) -- end flashlightrollout

rollout SettingRollout "Settings"
(
	dropdownlist drpType "LightType" items:#("Plane","Dome","Sphere","Mesh")
	spinner spnMultiplier "Intensity" range:[0,15000,1000] align:#right
	spinner spnSize0 "Length" range:[0,100,10] align:#right
	spinner spnSize1 "Width" range:[0,100,10] align:#right
	spinner spnSubdivs "Subdivs." range:[0,100,12] align:#right
	colorpicker clrPick "Color" color:white align:#right	
	
	on drpType selected type do
	(
		if drpType.selection == 3 then
		(
			spnSize0.caption = "Radius:"
			spnSize1.enabled = false
		)
		else
		(
			spnSize0.caption = "Length:"
			spnSize1.enabled = true
		)
	) -- end change dropdownlist
)

	
rollout Ueber "About"
(
	hyperlink link1 "by xcEmUx"   color: white hovercolor: orange visitedcolor: gray address: "http:\\\www.xcEmUx.DAPortfolio.com" align:#center
)

Rolloutfloat = newRolloutFloater "Flashlight" 200 200
addrollout FlashLightRollout Rolloutfloat
addrollout SettingRollout Rolloutfloat
addrollout Ueber Rolloutfloat
SettingRollout.open = 0
ueber.open = 0
)
catch
(
)