rollout Lightcutter "Lightcutter"
(
	group "Options:"
	(
	spinner VertLights "Vertical Lights:" range: [1, 100, 4] type:#integer 
	spinner HorzLights "Horizontal Lights:" range: [1, 100, 4] type:#integer
	spinner sldSize "Scale [%]" range: [0.1, 250.0, 100.0] type:#float
	checkbox chkDeleteold "Delete Main Light" checked: false align:#left
	button btndeletemainLight "Delete Main Light" enabled: false pos:[122, 88] height: 15 width: 90
	)
	group "Settings" 
	(
	pickbutton picklight "Pick Light" align:#left pos: [10, 128] height:17 width: 70 
	button btnExecute "Cut Light" align:#left pos: [10, 148] height:17 width: 70
	button btndelete "Delete Lights" align:#left pos: [10, 168] height:17 width: 70
	colorpicker LightColor "Color:" color: [255,255,255] modal:false pos:[125, 128] height:15 
	spinner spnIntensity "Intensity:" range: [0.1, 1000, 30] type:#float width: 75 pos:[135, 148]
	spinner spnSubdivs "Subdivs:" range: [1, 512, 8] type:#integer pos:[135, 168] width: 75
	label lbl1 "Type:" pos:[105, 188]
	dropdownlist ddType "" items:#("Plane", "Dome", "Sphere", "Mesh") width: 75 pos: [135, 188] 
	checkbox chkVisible "Invisible" checked: false pos:[10, 188] 
	)
	
	button btnrndcolors1 " " pos: [220, 260] width: 5 height: 5
	button btnrndcolors2 " " pos: [0, 260] width: 5 height: 5
	progressbar prgExecution color:black height: 10 pos:[10, 225]
	button help "?" height:15 width:15 align:#center border:false offset: [0,3]
		
	local LightArray = #()
	
	fn randomcolors =
	(
		if lightarray != undefined do 
		(
			for i = 1 to lightarray.count do 
			(
				farbe = [random 0 255, random 0 255, random 0 255] as point3
				lightarray [i].color = farbe
			)
		)
	) -- end fn randomcolors
	
	on btnrndcolors1 pressed Do 
	(
		randomcolors ()
	)
	
		on btnrndcolors2 pressed Do 
	(
		randomcolors ()
	)
	
	on btndeletemainlight pressed Do
	(
		delete picklight.object
	)
	on ddType selected thetype do
	(
		if lightarray != undefined do
		(
			for i = 1 to lightarray.count do 
			(
				lightarray[i].type = ddType.selection - 1
			)
		)
	)
	
	on chkVisible changed checked do
	(
		if lightarray != undefined do
		(
			for i = 1 to lightarray.count do
			(
				lightarray [i].invisible = chkVisible.checked
			)
		)
	)
	
	on lightcolor changed color do
	(
		if lightarray != undefined do
		(
			for i = 1 to lightarray.count do
			(
				lightarray [i].color = lightcolor.color
			) -- end for-loop
		) -- end if
	) -- end lightcolor
	
	on spnIntensity changed value do
	(
		if lightarray != undefined do
		(
			for i = 1 to lightarray.count do
			(
				lightarray [i].multiplier = spnIntensity.value
			)
		)
	) -- end spnIntensity
	
	on spnSubdivs changed value do
	(
		if lightarray != undefined do
		(
			for i = 1 to lightarray.count do
			(
				lightarray [i].subdivs = spnSubdivs.value
			)
		)
	) -- end spnSubdivs
	
	fn createlights =
	(

		delete lightarray
		lightarray = #()
		
		if picklight.object != undefined do
			(
				Lightpos = picklight.object.pos
				Lightrot = picklight.object.rotation
				LightWidth = picklight.object.size0 * 2
				LightHeight = picklight.object.size1 * 2
				
				p1 = plane pos: lightpos  width: Lightwidth length: Lightheight lengthsegs: vertlights.value widthsegs: HorzLights.value	rotation:lightrot
				
				convertto p1 editable_poly
				
				Polycount = getnumfaces p1
				
				for i = 1 to polycount do
				(
					PartLightPos = polyop.getfacecenter p1 i
					lighttype = ddType.selection - 1 as integer
					v1 = vraylight  pos:PartLightPos size0: 5 size1: 5 color: Lightcolor.color subdivs: spnSubdivs.value multiplier:spnIntensity.value invisible: chkVisible.checked type:lighttype
					v1.name =  "Cutted_Light_00" + i as string
					
					rotate v1 lightrot
					append Lightarray v1
					
					prgExecution.value += 100 / polycount
				) -- end For-Loop
				
				delete p1
				if chkDeleteold.checked == true then
				(
					delete picklight.object
				)
			) -- end if
	)
	
	on vertlights changed value do
	(
		createlights ()
	)
	
	on HorzLights changed value do
	(
		createlights ()
	) 
	
	on btnexecute pressed do
	(
		createlights ()
	) 
		
	on picklight picked object do
	(
		-- if picklight.object.classID == #(1012233633, 1607860959) then
		-- (
			-- if picklight.object.type == 0 then 
			-- (
				picklight.text = picklight.object.name
				spnIntensity.value = picklight.object.multiplier
				btndeletemainLight.enabled = true
			-- )
		-- )
	)

	on sldSize changed value do
	(
		for i = 1 to Lightarray.count do
		(
			if lightarray != undefined do
			(
				 -- lightarray [i].size0 = lightarray [i].size0 / 100 * sldSize.value
				 -- lightarray [i].size1 = lightarray [i].size1 / 100 * sldSize.value
				Scaling = sldSize.value / 100
				scale lightarray [i] [Scaling, Scaling, Scaling]
			)
		) -- end for-loop
		sldsize.value =  100.0
	) -- end sldSize
	
	on btndelete pressed do
	(
		delete Lightarray
		lightarray = #()
	) -- end btndelete
	
	on help pressed do
	(
		
		messagebox ("To cut the Light, first pick a VRayLightPlane and change the settings to your likings. To create the cutted lights, simply click on 'Cut Light'. \n \n \n 							by xcEmUx '2011" )
	)

)
createdialog Lightcutter 225 265