try
(
	
rollout RotationRollout "Rotation" width:512 height:288
(
	groupBox grp1 "X-Axis:" pos:[32,34] width:144 height:136
	groupBox grp2 "Y-Axis:" pos:[184,34] width:144 height:136
	groupBox grp5 "Z-Axis:" pos:[336,34] width:144 height:136
	groupBox grp4 "Select Rows:" pos:[16,10] width:480 height:168
	button btnPlatte1 " " pos:[40,82] width:32 height:50 enabled:true
	button btnPlatte2 " " pos:[88,82] width:32 height:50
	button btnPlatte3 " " pos:[136,82] width:32 height:50
	button btnScheibe1 " " pos:[192,82] width:32 height:50
	button btnScheibe2 " " pos:[240,82] width:32 height:50
	button btnScheibe3 " " pos:[288,82] width:32 height:50
	button btnEbene1 "" pos:[384,130] width:50 height:26
	button btnEbene2 "" pos:[384,98] width:50 height:26
	button btnEbene3 "" pos:[384,66] width:50 height:26
	button btnRotPlatte1Down "v" pos:[40,138] width:32 height:24
	button btnRotPlatte1Up "^" pos:[40,52] width:32 height:24
	button btnRotPlatte2Down "v" pos:[88,138] width:32 height:24
	button btnRotPlatte2Up "^" pos:[88,52] width:32 height:24
	button btnRotPlatte3Down "v" pos:[136,138] width:32 height:24
	button btnRotPlatte3Up "^" pos:[136,52] width:32 height:24
	button btnRoScheibe1Down "v" pos:[192,138] width:32 height:24
	button btnRoScheibe1Up "^" pos:[192,52] width:32 height:24
	button btnRoScheibe2Down "v" pos:[240,138] width:32 height:24
	button btnRoScheibe2Up "^" pos:[240,52] width:32 height:24
	button btnRoScheibe3Down "v" pos:[288,138] width:32 height:24
	button btnRoScheibe3Up "^" pos:[288,52] width:32 height:24
	button btnEbene1Left "<" pos:[344,130] width:32 height:24
	button btnEbene2Left "<" pos:[344,98] width:32 height:24
	button btnEbene3Left "<" pos:[344,66] width:32 height:24
	button btnEbene1Right ">" pos:[440,130] width:32 height:24
	button btnEbene2Right ">" pos:[440,98] width:32 height:24
	button btnEbene3Right ">" pos:[440,66] width:32 height:24
	
	-- Platte = X-Achse
	-- Scheibe = Y-Achse
	-- Ebene = Z-Achse
	
	global Platte1 = #()
	global Platte2 = #()
	global Platte3 = #()
	global Scheibe1 = #()
	global Scheibe2 = #()
	global Scheibe3 = #()
	global Ebene1 = #()
	global Ebene2 = #()
	global Ebene3 = #()
	global WrfelArray = #()
	global Offset = [0,0,0] as point3
	
	fn CheckWrfelArray =
	(
		TempArray = WrfelArray
		WrfelArray = #()
		for obj in TempArray where not isdeleted obj do
		(
			append WrfelArray obj
		)
	)
	
	fn RotateFunction obj rotation = 
	( 
		local axis
		local objA = if classof obj == objectSet or classof obj == array then obj else #(obj)

		if getCoordCenter() != #local then
		( 
			axis = getTransformAxis objA[1] 0
			for obj1 in objA do in coordsys axis about axis rotate obj1 rotation
		)
		else
		( 
			for obj1 in objA do
			( 
				axis = getTransformAxis obj1 0
				in coordsys axis about axis rotate obj1 rotation
			)
		)
	)
	
	fn axisRotate obj rotation = 
	( 
		local axis
		local objA = if classof obj == objectSet or classof obj == array then obj else #(obj)

		if getCoordCenter() != #local then
		( 
			axis = getTransformAxis objA[1] 0
			for obj1 in objA do in coordsys axis about axis rotate obj1 rotation
		)
		else
		( 
			for obj1 in objA do
			( 
				axis = getTransformAxis obj1 0
				in coordsys axis about axis rotate obj1 rotation
			)
		)
	)
	
	fn CreateRow1 =
	(
		for i = 1 to 3 do
		(
			a = ChamferBox height:10 length:10 width:10 wirecolor:red Fillet:0.5 smooth:0
			Offset.x += -11 * i
			move a Offset
			Offset.x = 0
			append WrfelArray a
			
		
			for j = 1 to 3 do
			(
				b = copy a
				b.wirecolor = blue
				Offset.y += -11 * j
				move b Offset
				Offset.y = 0
				append WrfelArray b
				
			
				for k = 1 to 3 do
				(
					
					c = copy b
					c.wirecolor = gray
					Offset.z += -11 * k
					move c Offset
					Offset.z = 0
					append WrfelArray c
					
				)
				delete b
			)
			delete a
		) -- end Creation Loops
		
		CheckWrfelArray ()
		
		move WrfelArray [22,22,17]

	) -- end function CreateCube
	
	fn CheckPos =
	(
		 CheckWrfelArray ()
		 Platte1 = #()
		 Platte2 = #()
		 Platte3 = #()
		 Scheibe1 = #()
		 Scheibe2 = #()
		 Scheibe3 = #()
		 Ebene1 = #()
		 Ebene2 = #()
		 Ebene3 = #()
		 
		for obj in WrfelArray where obj.transform.row4.x < 0 do
		(
			CenterPivot Obj
			append Platte1 obj
		)
		for obj in WrfelArray where obj.transform.row4.x == 0 do
		(
			CenterPivot Obj
			append Platte2 obj
		)
		for obj in WrfelArray where obj.transform.row4.x > 0 do
		(
			CenterPivot Obj
			append Platte3 obj
		)
		
		for obj in WrfelArray where obj.transform.row4.y < 0 do
		(
			CenterPivot Obj
			append Scheibe1 obj
		)
		for obj in WrfelArray where obj.transform.row4.y == 0 do
		(
			CenterPivot Obj
			append Scheibe2 obj
		)
		for obj in WrfelArray where obj.transform.row4.y > 0 do
		(
			CenterPivot Obj
			append Scheibe3 obj
		)
		
		for obj in WrfelArray where obj.transform.row4.z < 0 do
		(
			CenterPivot Obj
			append Ebene1 obj
		)
		for obj in WrfelArray where obj.transform.row4.z == 0 do
		(
			CenterPivot Obj
			append Ebene2 obj
		)
		for obj in WrfelArray where obj.transform.row4.z > 0 do
		(
			CenterPivot Obj
			append Ebene3 obj
		)
	) -- end funcion CheckPos
	
	
	----------- Select Items -------------
		on btnPlatte1 pressed  do
		(
			CheckPos ()
			select Platte1
		)
	on btnPlatte2 pressed  do
		(
			CheckPos ()
			select Platte2
		)
	on btnPlatte3 pressed  do
		(
			CheckPos ()
			select Platte3
		)
	on btnScheibe1 pressed  do
		(
			CheckPos ()
			select Scheibe1
		)
	on btnScheibe2 pressed  do
		(
			CheckPos ()
			select Scheibe2
		)
	on btnScheibe3 pressed  do
		(
			CheckPos ()
			select Scheibe3
		)
	on btnEbene1 pressed  do
		(
			CheckPos ()
			select Ebene1
		)
	on btnEbene2 pressed  do
		(
			CheckPos ()
			select Ebene2
		)
	on btnEbene3 pressed  do
		(
			CheckPos ()
			select Ebene3
		)
	
	----------- Rotate Items ----------
	on btnRotPlatte1Down pressed  do
		(
			CheckPos ()
			select Platte1
			AxisRotate $ (angleaxis 90 [1,0,0])
		)
	on btnRotPlatte1Up pressed  do
		(
			CheckPos ()
			select Platte1
			AxisRotate $ (angleaxis -90 [1,0,0])
		)
	on btnRotPlatte2Down pressed  do
		( 
			CheckPos ()
			select Platte2
			AxisRotate $ (angleaxis 90 [1,0,0])
		)
	on btnRotPlatte2Up pressed  do
		(
			CheckPos ()
			select Platte2
			AxisRotate $ (angleaxis -90 [1,0,0])
		)
	on btnRotPlatte3Down pressed  do
		(
			CheckPos ()
			select Platte3
			AxisRotate $ (angleaxis 90 [1,0,0])
		)
	on btnRotPlatte3Up pressed  do
		(
			CheckPos ()
			select Platte3
			AxisRotate $ (angleaxis -90 [1,0,0])
		)
	on btnRoScheibe1Down pressed  do
		(
			CheckPos ()
			select Scheibe1
			AxisRotate $ (angleaxis 90 [0,1,0])
		)
	on btnRoScheibe1Up pressed  do
		(
			CheckPos ()
			select Scheibe1
			AxisRotate $ (angleaxis -90 [0,1,0])
		)
	on btnRoScheibe2Down pressed  do
		(
			CheckPos ()
			select Scheibe2
			AxisRotate $ (angleaxis 90 [0,1,0])
		)
	on btnRoScheibe2Up pressed  do
		(
			CheckPos ()
			select Scheibe2
			AxisRotate $ (angleaxis -90 [0,1,0])
		)
	on btnRoScheibe3Down pressed  do
		(
			CheckPos ()
			select Scheibe3
			AxisRotate $ (angleaxis 90 [0,1,0])
		)
	on btnRoScheibe3Up pressed  do
		(
			CheckPos ()
			select Scheibe3
			AxisRotate $ (angleaxis -90 [0,1,0])
		)
	on btnEbene1Left pressed  do
		(
			CheckPos ()
			select Ebene1
			AxisRotate $ (angleaxis -90 [0,0,1])
		)
	on btnEbene2Left pressed  do
		(
			CheckPos ()
			select Ebene2
			AxisRotate $ (angleaxis -90 [0,0,1])
		)
	on btnEbene3Left pressed  do
		(
			CheckPos ()
			select Ebene3
			AxisRotate $ (angleaxis -90 [0,0,1])
		)
	on btnEbene1Right pressed  do
		(
			CheckPos ()
			select Ebene1
			AxisRotate $ (angleaxis 90 [0,0,1])
		)
	on btnEbene2Right pressed  do
		(
			CheckPos ()
			select Ebene2
			AxisRotate $ (angleaxis 90 [0,0,1])
		)
	on btnEbene3Right pressed  do
		(
			CheckPos ()
			select Ebene3
			AxisRotate $ (angleaxis 90 [0,0,1])
		)
	
)-- end Rollout
rollout CreationRollout "Creation"
(
	button btnCreateCube "Create Rubic Cube" pos:[16,8] width:480 height:24
	button btnAssignColors "Assign Colors" width:480 height:24 pos:[16,43]
	button btnRandomize "                             Randomize" width:395 height:24 pos:[16,78] -- enabled:false
	spinner spnRndCount "Count:" range:[1,100,10] type:#integer pos:[445,78] width:50 --enabled:false
	button btnDeleteCube "Delete Rubic Cube" width:480 height:24 pos:[16,113]
	
	fn CheckWrfelArray =
	(
		TempArray = WrfelArray
		WrfelArray = #()
		for obj in TempArray where not isdeleted obj do
		(
			append WrfelArray obj
		)
	)
	
	fn RotateFunction obj rotation = 
	( 
		local axis
		local objA = if classof obj == objectSet or classof obj == array then obj else #(obj)

		if getCoordCenter() != #local then
		( 
			axis = getTransformAxis objA[1] 0
			for obj1 in objA do in coordsys axis about axis rotate obj1 rotation
		)
		else
		( 
			for obj1 in objA do
			( 
				axis = getTransformAxis obj1 0
				in coordsys axis about axis rotate obj1 rotation
			)
		)
	)

	
	fn AxisRotate obj rotation = 
	( 
		local axis
		local objA = if classof obj == objectSet or classof obj == array then obj else #(obj)

		if getCoordCenter() != #local then
		( 
			axis = getTransformAxis objA[1] 0
			for obj1 in objA do in coordsys axis about axis rotate obj1 rotation
		)
		else
		( 
			for obj1 in objA do
			( 
				axis = getTransformAxis obj1 0
				in coordsys axis about axis rotate obj1 rotation
			)
		)
	)
	
	fn CreateRow1 =
	(
		for i = 1 to 3 do
		(
			a = ChamferBox height:10 length:10 width:10 wirecolor:red Fillet:0.5 smooth:0
			Offset.x += -11 * i
			move a Offset
			Offset.x = 0
			append WrfelArray a
			
		
			for j = 1 to 3 do
			(
				b = copy a
				b.wirecolor = blue
				Offset.y += -11 * j
				move b Offset
				Offset.y = 0
				append WrfelArray b
				
			
				for k = 1 to 3 do
				(
					
					c = copy b
					c.wirecolor = gray
					Offset.z += -11 * k
					move c Offset
					Offset.z = 0
					append WrfelArray c
					
				)
				delete b
			)
			delete a
		) -- end Creation Loops
		
		CheckWrfelArray ()
		
		move WrfelArray [22,22,17]

	) -- end function CreateCube
	
	fn CheckPos =
	(
		 CheckWrfelArray ()
		 Platte1 = #()
		 Platte2 = #()
		 Platte3 = #()
		 Scheibe1 = #()
		 Scheibe2 = #()
		 Scheibe3 = #()
		 Ebene1 = #()
		 Ebene2 = #()
		 Ebene3 = #()
		 
		for obj in WrfelArray where obj.transform.row4.x < 0 do
		(
			CenterPivot Obj
			append Platte1 obj
		)
		for obj in WrfelArray where obj.transform.row4.x == 0 do
		(
			CenterPivot Obj
			append Platte2 obj
		)
		for obj in WrfelArray where obj.transform.row4.x > 0 do
		(
			CenterPivot Obj
			append Platte3 obj
		)
		
		for obj in WrfelArray where obj.transform.row4.y < 0 do
		(
			CenterPivot Obj
			append Scheibe1 obj
		)
		for obj in WrfelArray where obj.transform.row4.y == 0 do
		(
			CenterPivot Obj
			append Scheibe2 obj
		)
		for obj in WrfelArray where obj.transform.row4.y > 0 do
		(
			CenterPivot Obj
			append Scheibe3 obj
		)
		
		for obj in WrfelArray where obj.transform.row4.z < 0 do
		(
			CenterPivot Obj
			append Ebene1 obj
		)
		for obj in WrfelArray where obj.transform.row4.z == 0 do
		(
			CenterPivot Obj
			append Ebene2 obj
		)
		for obj in WrfelArray where obj.transform.row4.z > 0 do
		(
			CenterPivot Obj
			append Ebene3 obj
		)
	) -- end funcion CheckPos
	
	on btnCreateCube pressed do
	(
		CreateRow1	()
	) -- end btnCreateCube
	
	on btnRandomize pressed do
	(
		for i = 1 to spnRndCount.value do
		(
			a = random 1 18
			case a of 
			(
				1:
				(
					CheckPos ()
					select Platte1
					AxisRotate $ (angleaxis 90 [1,0,0])
				)
				2:
				(
					CheckPos ()
					select Platte1
					AxisRotate $ (angleaxis -90 [1,0,0])
				)
				3:
				(
					CheckPos ()
					select Platte2
					AxisRotate $ (angleaxis 90 [1,0,0])
				)
				4:
				(
					CheckPos ()
					select Platte2
					AxisRotate $ (angleaxis -90 [1,0,0])
				)
				5:
				(
					CheckPos ()
					select Platte3
					AxisRotate $ (angleaxis 90 [1,0,0])
				)
				6:
				(
					CheckPos ()
					select Platte3
					AxisRotate $ (angleaxis -90 [1,0,0])
				)
				7:
				(
					CheckPos ()
					select Scheibe1
					AxisRotate $ (angleaxis 90 [0,1,0])
				)
				8:
				(
					CheckPos ()
					select Scheibe1
					AxisRotate $ (angleaxis -90 [0,1,0])
				)
				9:
				(
					CheckPos ()
					select Scheibe2
					AxisRotate $ (angleaxis 90 [0,1,0])
				)
				10:
				(
					CheckPos ()
					select Scheibe2
					AxisRotate $ (angleaxis -90 [0,1,0])
				)
				11:
				(
					CheckPos ()
					select Scheibe3
					AxisRotate $ (angleaxis 90 [0,1,0])
				)
				12:
				(
					CheckPos ()
					select Scheibe3
					AxisRotate $ (angleaxis -90 [0,1,0])
				)
				13:
				(
					CheckPos ()
					select Ebene1
					AxisRotate $ (angleaxis 90 [0,0,1])
				)
				14:
				(
					CheckPos ()
					select  Ebene1
					AxisRotate $ (angleaxis -90 [0,0,1])
				)
				15:
				(
					CheckPos ()
					select  Ebene2
					AxisRotate $ (angleaxis 90 [0,0,1])
				)
				16:
				(
					CheckPos ()
					select  Ebene2
					AxisRotate $ (angleaxis -90 [0,0,1])
				)
				17:
				(
					CheckPos ()
					select  Ebene3
					AxisRotate $ (angleaxis 90 [0,0,1])
				)
				18:
				(
					CheckPos ()
					select  Ebene3
					AxisRotate $ (angleaxis -90 [0,0,1])
				)
			)
		)
	) -- end btnRandomize pressed
	
	on btnDeleteCube pressed do
	(
		if WrfelArray != undefined then
		(
			delete WrfelArray 
			Platte1 = #()
			Platte2 = #()
			Platte3 = #()
			Scheibe1 = #()
			Scheibe2 = #()
			Scheibe3 = #()
			Ebene1 = #()
			Ebene2 = #()
			Ebene3 = #()
			WrfelArray = #()
		)
		else ()
	)
	
	on btnAssignColors pressed do
	(
		if wrfelarray != undefined then
		(
			select wrfelarray
			for i = 1 to wrfelarray.count do
			(
				convertto Wrfelarray[i] Editable_Poly
			)
			
			for i = 2 to Wrfelarray.count by 1 do
			(
				Wrfelarray[1].attach WrfelArray[i] Wrfelarray[1]
			)
			
			MaterialArray = #()
			
			Blau = standard diffuse:blue specularLevel:25 Glossiness:35
			append MaterialArray Blau
			Wei = standard diffuse:white specularLevel:25 Glossiness:35
			append MaterialArray Wei
			Rot = standard diffuse:red
			append MaterialArray Rot
			Grn = standard diffuse:green specularLevel:25 Glossiness:35
			append MaterialArray Grn
			Gelb = standard diffuse:yellow specularLevel:25 Glossiness:35
			append MaterialArray Gelb
			Orang = standard diffuse:orange specularLevel:25 Glossiness:35
			append MaterialArray Orang
			Schwarz = standard diffuse:black specularLevel:25 Glossiness:35
			append MaterialArray Schwarz
			
			MultiMat = multimaterial numsubs:7 MaterialList:MaterialArray
			
			PolyOp.SetFaceMatID $ #{61, 175, 289, 403, 517, 631, 745, 859, 973} 4
			PolyOp.SetFaceMatID $ #{65, 179, 293, 1091, 1205, 1319, 2117, 2231, 2345} 2
			PolyOp.SetFaceMatID $ #{2105, 2219, 2333, 2447, 2561, 2675, 2789, 2903, 3017} 3
			PolyOp.SetFaceMatID $ #{741, 855, 969, 1767, 1881, 1995, 2793, 2907, 3021} 1
			PolyOp.SetFaceMatID $ #{1, 343, 685, 1027, 1369, 1711, 2053, 2395, 2737} 5
			PolyOp.SetFaceMatID $ #{342, 684, 1026, 1368, 1710, 2052, 2394, 2736, 3078} 6
			PolyOp.SetFaceMatID $ #{2..60, 62..64, 66..174, 176..178, 180..288, 290..292, 294..341, 344..402, 404..516, 518..630, 632..683,\
			686..740, 742..744, 746..854, 856..858, 860..968, 970..972, 974..1025, 1028..1090, 1092..1204, 1206..1318, 1320..1367, 1370..1709, \
			1712..1766, 1768..1880, 1882..1994, 1996..2051, 2054..2104, 2106..2116, 2118..2218, 2220..2230, 2232..2332, 2334..2344, 2346..2393, \
			2396..2446, 2448..2560, 2562..2674, 2676..2735, 2738..2788, 2790..2792, 2794..2902, 2904..2906, 2908..3016, 3018..3020, 3022..3077} 7
			
			PolyOp.SetFaceSmoothGroup $ #{2..60, 62..64, 66..174, 176..178, 180..288, 290..292, 294..341, 344..402, 404..516, 518..630, 632..683,\
			686..740, 742..744, 746..854, 856..858, 860..968, 970..972, 974..1025, 1028..1090, 1092..1204, 1206..1318, 1320..1367, 1370..1709, \
			1712..1766, 1768..1880, 1882..1994, 1996..2051, 2054..2104, 2106..2116, 2118..2218, 2220..2230, 2232..2332, 2334..2344, 2346..2393, \
			2396..2446, 2448..2560, 2562..2674, 2676..2735, 2738..2788, 2790..2792, 2794..2902, 2904..2906, 2908..3016, 3018..3020, 3022..3077} 4
			
			CheckWrfelArray ()
			WrfelArray.material = MultiMat
			WrfelArray = #()
			
			for i = 1 to 27 do
			(
				BoxName = "RubicCube_Box_" + i as string
				PolyOp.SetFaceSelection $ #{1}
				$.ConvertSelection #Face #Element
				a = polyop.getfaceselection $
				PolyOp.DetachFaces $ a asnode:true name:BoxName
			) 
			select  $RubicCube_Box_*
			for i = 1 to selection.count do
			(
				append WrfelArray selection[i]
			)
			CheckPos ()
			actionMan.executeAction 0 "40077"
		)
	)
)

rollout Ueber "About"
(
	hyperlink link1 "by xcEmUx"   color: white hovercolor: orange visitedcolor: gray address: "http:\\\www.xcEmUx.DAPortfolio.com" align:#center
)

Rolloutfloat = newRolloutFloater "Rubic Cube Animation v.0.5" 515 410
addrollout RotationRollout Rolloutfloat
addrollout CreationRollout Rolloutfloat
addrollout Ueber Rolloutfloat
ueber.open = 0
)
catch
(
)