-- Script shows the length / distance to Tape.target of every unhidden target in the scene
-- Use and Modify on your  own risk
-- xcEmUx '2011

rollout TapeLengthViewport "Tape Length in Viewport"
(
	
	colorpicker theColor "Font Color:" color:[255,255,0] modal:false align:#left offset:[75,17]
	label lbl1 "Show:" pos:[88,60]
	radiobuttons rdnDistLength labels:#("Distance","Length") default: 1 align:#left columns:1  offset:[115,-18]
	slider sldOffset "Text Offset:" range:[-50,50,5] align:#left orient:#vertical ticks: 20 pos: [10, 25] 
	label lblOffset "5.0" pos: [43,90] style_sunkenedge:true width: 28 height: 20
	groupbox grpBox1 "Settings" pos:[5,5] width:200 height:125
	label lblTapes "Tapes in Scene:" pos: [5,135] style_sunkenedge: true width: 150 height: 15
	label lblHiddenTapes "Hidden Tapes:" pos: [5,150] style_sunkenedge: true width: 150 height: 15
	button btnRefresh "Refresh" pos: [155,135] width: 50 height:30
	checkbutton chkbtnShowText "Show Length" highlightcolor: [200,125,0] pos:[5,175] height:20 width: 200
	hyperlink hypLink "by xcEmUx" color: orange hovercolor:black visitedcolor:gray address: "http://www.xcEmUx.DAPortfolio.com" 
	label lbl2 " '2011" pos: [171,200] style_sunkenedge:true height: 15 width: 33
	timer Clocktimer 
	
	local TapeObjs = #()
	
	fn ShowLength = 
	(
		gw.settransform (matrix3 1)
		TapeObjs = for o in objects where classof o == Tape and  not o.ishidden collect o
		
		for i= 1 to TapeObjs.count do
		(			
			TapePos = TapeObjs[i].pos 
			TapePos.z += sldOffset.value
			
			TapeLength = (units.formatvalue TapeObjs[i].length) as string
			TapeDistance = (units.formatvalue (distance TapeObjs[i] TapeObjs[i].target)) as string
			
			case rdnDistLength.state of
			(
			1: gw.text Tapepos TapeDistance color:thecolor.color
			2: gw.text Tapepos TapeLength color:thecolor.color
			)
			
		) -- end for-loop
			gw.enlargeupdaterect #whole
			gw.updateScreen()
	) -- end fn ShowLength
	
	on btnRefresh pressed do
	(
		Tapes = for o in objects where classof o == Tape and  not o.ishidden collect o
		lblTapes.text = "  Tape Objects in Scene:  " + Tapes.count as string
		
		HiddenTapes = for o in objects where classof o == Tape and o.ishidden collect o
		lblHiddenTapes.text = "  Hidden Tape Objects:    " + HiddenTapes.count as string
	)
	
	on sldOffset changed value do
	(
		lblOffset.text = sldOffset.value as string
	) -- end sldOffset changed
	
	on chkbtnShowText changed state do
	(
		if chkbtnShowText.checked == true then
			registerRedrawViewsCallback ShowLength
		else
			unregisterRedrawViewsCallback ShowLength
	) -- end btnShowText
	
	on TapeLengthViewport open do
	(
		Tapes = for o in objects where classof o == Tape and  not o.ishidden collect o
		lblTapes.text = "  Tape Objects in Scene:  " + Tapes.count as string
		
		HiddenTapes = for o in objects where classof o == Tape and o.ishidden collect o
		lblHiddenTapes.text = "  Hidden Tape Objects:    " + HiddenTapes.count as string
	) -- end Rollout open
	
	on TapeLengthViewport close do
	(
		unregisterRedrawViewsCallback ShowLength
	) -- end Rollout Close
	
) -- end rollout
createdialog TapeLengthViewport 210 220